/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.chukwa.rest.objects;

// Generated May 28, 2009 3:39:53 PM by Hibernate Tools 3.2.4.GA

import java.sql.Timestamp;

/**
 * DfsThroughput generated by hbm2java
 */
public class DfsThroughput implements java.io.Serializable {
    static final long serialVersionUID = -6427859980989082243L;

    private Timestamp timestamp;
    private Integer host;
    private Double blockReportsAvgTime;
    private Double blockReportsNumOps;
    private Double blockVerificationFailures;
    private Double blocksRead;
    private Double blocksRemoved;
    private Double blocksReplicated;
    private Double blocksVerified;
    private Double blocksWritten;
    private Double bytesRead;
    private Double bytesWritten;
    private Double copyBlockOpAvgTime;
    private Double copyBlockOpNumOps;
    private Double heartBeatsAvgTime;
    private Double heartBeatsNumOps;
    private Double readBlockOpAvgTime;
    private Double readBlockOpNumOps;
    private Double readMetadataOpAvgTime;
    private Double readMetadataOpNumOps;
    private Double readsFromLocalClient;
    private Double readsFromRemoteClient;
    private Double replaceBlockOpAvgTime;
    private Double replaceBlockOpNumOps;
    private Double sessionId;
    private Double writeBlockOpAvgTime;
    private Double writeBlockOpNumOps;
    private Double writesFromLocalClient;
    private Double writesFromRemoteClient;

    public DfsThroughput() {
    }

    public DfsThroughput(Timestamp timestamp) {
	this.timestamp = timestamp;
    }

    public DfsThroughput(Timestamp timestamp, Integer host,
			 Double blockReportsAvgTime, Double blockReportsNumOps,
			 Double blockVerificationFailures, Double blocksRead,
			 Double blocksRemoved, Double blocksReplicated,
			 Double blocksVerified, Double blocksWritten, Double bytesRead,
			 Double bytesWritten, Double copyBlockOpAvgTime,
			 Double copyBlockOpNumOps, Double heartBeatsAvgTime,
			 Double heartBeatsNumOps, Double readBlockOpAvgTime,
			 Double readBlockOpNumOps, Double readMetadataOpAvgTime,
			 Double readMetadataOpNumOps, Double readsFromLocalClient,
			 Double readsFromRemoteClient, Double replaceBlockOpAvgTime,
			 Double replaceBlockOpNumOps, Double sessionId,
			 Double writeBlockOpAvgTime, Double writeBlockOpNumOps,
			 Double writesFromLocalClient, Double writesFromRemoteClient) {
	this.timestamp = timestamp;
	this.host = host;
	this.blockReportsAvgTime = blockReportsAvgTime;
	this.blockReportsNumOps = blockReportsNumOps;
	this.blockVerificationFailures = blockVerificationFailures;
	this.blocksRead = blocksRead;
	this.blocksRemoved = blocksRemoved;
	this.blocksReplicated = blocksReplicated;
	this.blocksVerified = blocksVerified;
	this.blocksWritten = blocksWritten;
	this.bytesRead = bytesRead;
	this.bytesWritten = bytesWritten;
	this.copyBlockOpAvgTime = copyBlockOpAvgTime;
	this.copyBlockOpNumOps = copyBlockOpNumOps;
	this.heartBeatsAvgTime = heartBeatsAvgTime;
	this.heartBeatsNumOps = heartBeatsNumOps;
	this.readBlockOpAvgTime = readBlockOpAvgTime;
	this.readBlockOpNumOps = readBlockOpNumOps;
	this.readMetadataOpAvgTime = readMetadataOpAvgTime;
	this.readMetadataOpNumOps = readMetadataOpNumOps;
	this.readsFromLocalClient = readsFromLocalClient;
	this.readsFromRemoteClient = readsFromRemoteClient;
	this.replaceBlockOpAvgTime = replaceBlockOpAvgTime;
	this.replaceBlockOpNumOps = replaceBlockOpNumOps;
	this.sessionId = sessionId;
	this.writeBlockOpAvgTime = writeBlockOpAvgTime;
	this.writeBlockOpNumOps = writeBlockOpNumOps;
	this.writesFromLocalClient = writesFromLocalClient;
	this.writesFromRemoteClient = writesFromRemoteClient;
    }

    public Timestamp getTimestamp() {
	return this.timestamp;
    }

    public void setTimestamp(Timestamp timestamp) {
	this.timestamp = timestamp;
    }

    public Integer getHost() {
	return this.host;
    }

    public void setHost(Integer host) {
	this.host = host;
    }

    public Double getBlockReportsAvgTime() {
	return this.blockReportsAvgTime;
    }

    public void setBlockReportsAvgTime(Double blockReportsAvgTime) {
	this.blockReportsAvgTime = blockReportsAvgTime;
    }

    public Double getBlockReportsNumOps() {
	return this.blockReportsNumOps;
    }

    public void setBlockReportsNumOps(Double blockReportsNumOps) {
	this.blockReportsNumOps = blockReportsNumOps;
    }

    public Double getBlockVerificationFailures() {
	return this.blockVerificationFailures;
    }

    public void setBlockVerificationFailures(Double blockVerificationFailures) {
	this.blockVerificationFailures = blockVerificationFailures;
    }

    public Double getBlocksRead() {
	return this.blocksRead;
    }

    public void setBlocksRead(Double blocksRead) {
	this.blocksRead = blocksRead;
    }

    public Double getBlocksRemoved() {
	return this.blocksRemoved;
    }

    public void setBlocksRemoved(Double blocksRemoved) {
	this.blocksRemoved = blocksRemoved;
    }

    public Double getBlocksReplicated() {
	return this.blocksReplicated;
    }

    public void setBlocksReplicated(Double blocksReplicated) {
	this.blocksReplicated = blocksReplicated;
    }

    public Double getBlocksVerified() {
	return this.blocksVerified;
    }

    public void setBlocksVerified(Double blocksVerified) {
	this.blocksVerified = blocksVerified;
    }

    public Double getBlocksWritten() {
	return this.blocksWritten;
    }

    public void setBlocksWritten(Double blocksWritten) {
	this.blocksWritten = blocksWritten;
    }

    public Double getBytesRead() {
	return this.bytesRead;
    }

    public void setBytesRead(Double bytesRead) {
	this.bytesRead = bytesRead;
    }

    public Double getBytesWritten() {
	return this.bytesWritten;
    }

    public void setBytesWritten(Double bytesWritten) {
	this.bytesWritten = bytesWritten;
    }

    public Double getCopyBlockOpAvgTime() {
	return this.copyBlockOpAvgTime;
    }

    public void setCopyBlockOpAvgTime(Double copyBlockOpAvgTime) {
	this.copyBlockOpAvgTime = copyBlockOpAvgTime;
    }

    public Double getCopyBlockOpNumOps() {
	return this.copyBlockOpNumOps;
    }

    public void setCopyBlockOpNumOps(Double copyBlockOpNumOps) {
	this.copyBlockOpNumOps = copyBlockOpNumOps;
    }

    public Double getHeartBeatsAvgTime() {
	return this.heartBeatsAvgTime;
    }

    public void setHeartBeatsAvgTime(Double heartBeatsAvgTime) {
	this.heartBeatsAvgTime = heartBeatsAvgTime;
    }

    public Double getHeartBeatsNumOps() {
	return this.heartBeatsNumOps;
    }

    public void setHeartBeatsNumOps(Double heartBeatsNumOps) {
	this.heartBeatsNumOps = heartBeatsNumOps;
    }

    public Double getReadBlockOpAvgTime() {
	return this.readBlockOpAvgTime;
    }

    public void setReadBlockOpAvgTime(Double readBlockOpAvgTime) {
	this.readBlockOpAvgTime = readBlockOpAvgTime;
    }

    public Double getReadBlockOpNumOps() {
	return this.readBlockOpNumOps;
    }

    public void setReadBlockOpNumOps(Double readBlockOpNumOps) {
	this.readBlockOpNumOps = readBlockOpNumOps;
    }

    public Double getReadMetadataOpAvgTime() {
	return this.readMetadataOpAvgTime;
    }

    public void setReadMetadataOpAvgTime(Double readMetadataOpAvgTime) {
	this.readMetadataOpAvgTime = readMetadataOpAvgTime;
    }

    public Double getReadMetadataOpNumOps() {
	return this.readMetadataOpNumOps;
    }

    public void setReadMetadataOpNumOps(Double readMetadataOpNumOps) {
	this.readMetadataOpNumOps = readMetadataOpNumOps;
    }

    public Double getReadsFromLocalClient() {
	return this.readsFromLocalClient;
    }

    public void setReadsFromLocalClient(Double readsFromLocalClient) {
	this.readsFromLocalClient = readsFromLocalClient;
    }

    public Double getReadsFromRemoteClient() {
	return this.readsFromRemoteClient;
    }

    public void setReadsFromRemoteClient(Double readsFromRemoteClient) {
	this.readsFromRemoteClient = readsFromRemoteClient;
    }

    public Double getReplaceBlockOpAvgTime() {
	return this.replaceBlockOpAvgTime;
    }

    public void setReplaceBlockOpAvgTime(Double replaceBlockOpAvgTime) {
	this.replaceBlockOpAvgTime = replaceBlockOpAvgTime;
    }

    public Double getReplaceBlockOpNumOps() {
	return this.replaceBlockOpNumOps;
    }

    public void setReplaceBlockOpNumOps(Double replaceBlockOpNumOps) {
	this.replaceBlockOpNumOps = replaceBlockOpNumOps;
    }

    public Double getSessionId() {
	return this.sessionId;
    }

    public void setSessionId(Double sessionId) {
	this.sessionId = sessionId;
    }

    public Double getWriteBlockOpAvgTime() {
	return this.writeBlockOpAvgTime;
    }

    public void setWriteBlockOpAvgTime(Double writeBlockOpAvgTime) {
	this.writeBlockOpAvgTime = writeBlockOpAvgTime;
    }

    public Double getWriteBlockOpNumOps() {
	return this.writeBlockOpNumOps;
    }

    public void setWriteBlockOpNumOps(Double writeBlockOpNumOps) {
	this.writeBlockOpNumOps = writeBlockOpNumOps;
    }

    public Double getWritesFromLocalClient() {
	return this.writesFromLocalClient;
    }

    public void setWritesFromLocalClient(Double writesFromLocalClient) {
	this.writesFromLocalClient = writesFromLocalClient;
    }

    public Double getWritesFromRemoteClient() {
	return this.writesFromRemoteClient;
    }

    public void setWritesFromRemoteClient(Double writesFromRemoteClient) {
	this.writesFromRemoteClient = writesFromRemoteClient;
    }

}
