/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.chukwa.rest.objects;

// Generated May 28, 2009 3:39:53 PM by Hibernate Tools 3.2.4.GA

import java.sql.Timestamp;

/**
 * ClusterSystemMetrics generated by hbm2java
 */
public class ClusterSystemMetrics implements java.io.Serializable {

    static final long serialVersionUID = -2569521727910619893L;

    private Timestamp timestamp;
    private Integer host;
    private Double load15;
    private Double load5;
    private Double load1;
    private Double taskTotal;
    private Double taskRunning;
    private Double taskSleep;
    private Double taskStopped;
    private Double taskZombie;
    private Double memTotal;
    private Double memBuffers;
    private Double memCached;
    private Double memUsed;
    private Double memFree;
    private Double eth0Rxerrs;
    private Double eth0Rxbyts;
    private Double eth0Rxpcks;
    private Double eth0Rxdrops;
    private Double eth0Txerrs;
    private Double eth0Txbyts;
    private Double eth0Txpcks;
    private Double eth0Txdrops;
    private Double eth1Rxerrs;
    private Double eth1Rxbyts;
    private Double eth1Rxpcks;
    private Double eth1Rxdrops;
    private Double eth1Txerrs;
    private Double eth1Txbyts;
    private Double eth1Txpcks;
    private Double eth1Txdrops;
    private Double sdaRkbs;
    private Double sdaWkbs;
    private Double sdbRkbs;
    private Double sdbWkbs;
    private Double sdcRkbs;
    private Double sdcWkbs;
    private Double sddRkbs;
    private Double sddWkbs;
    private Float cpuIdlePcnt;
    private Float cpuNicePcnt;
    private Float cpuSystemPcnt;
    private Float cpuUserPcnt;
    private Float cpuHirqPcnt;
    private Float cpuSirqPcnt;
    private Float iowaitPcnt;
    private Float memBuffersPcnt;
    private Float memUsedPcnt;
    private Float eth0BusyPcnt;
    private Float eth1BusyPcnt;
    private Float sdaBusyPcnt;
    private Float sdbBusyPcnt;
    private Float sdcBusyPcnt;
    private Float sddBusyPcnt;
    private Float swapUsedPcnt;

    public ClusterSystemMetrics() {
    }

    public ClusterSystemMetrics(Timestamp timestamp) {
	this.timestamp = timestamp;
    }

    public ClusterSystemMetrics(Timestamp timestamp, Integer host,
				Double load15, Double load5, Double load1, Double taskTotal,
				Double taskRunning, Double taskSleep, Double taskStopped,
				Double taskZombie, Double memTotal, Double memBuffers,
				Double memCached, Double memUsed, Double memFree,
				Double eth0Rxerrs, Double eth0Rxbyts, Double eth0Rxpcks,
				Double eth0Rxdrops, Double eth0Txerrs, Double eth0Txbyts,
				Double eth0Txpcks, Double eth0Txdrops, Double eth1Rxerrs,
				Double eth1Rxbyts, Double eth1Rxpcks, Double eth1Rxdrops,
				Double eth1Txerrs, Double eth1Txbyts, Double eth1Txpcks,
				Double eth1Txdrops, Double sdaRkbs, Double sdaWkbs, Double sdbRkbs,
				Double sdbWkbs, Double sdcRkbs, Double sdcWkbs, Double sddRkbs,
				Double sddWkbs, Float cpuIdlePcnt, Float cpuNicePcnt,
				Float cpuSystemPcnt, Float cpuUserPcnt, Float cpuHirqPcnt,
				Float cpuSirqPcnt, Float iowaitPcnt, Float memBuffersPcnt,
				Float memUsedPcnt, Float eth0BusyPcnt, Float eth1BusyPcnt,
				Float sdaBusyPcnt, Float sdbBusyPcnt, Float sdcBusyPcnt,
				Float sddBusyPcnt, Float swapUsedPcnt) {
	this.timestamp = timestamp;
	this.host = host;
	this.load15 = load15;
	this.load5 = load5;
	this.load1 = load1;
	this.taskTotal = taskTotal;
	this.taskRunning = taskRunning;
	this.taskSleep = taskSleep;
	this.taskStopped = taskStopped;
	this.taskZombie = taskZombie;
	this.memTotal = memTotal;
	this.memBuffers = memBuffers;
	this.memCached = memCached;
	this.memUsed = memUsed;
	this.memFree = memFree;
	this.eth0Rxerrs = eth0Rxerrs;
	this.eth0Rxbyts = eth0Rxbyts;
	this.eth0Rxpcks = eth0Rxpcks;
	this.eth0Rxdrops = eth0Rxdrops;
	this.eth0Txerrs = eth0Txerrs;
	this.eth0Txbyts = eth0Txbyts;
	this.eth0Txpcks = eth0Txpcks;
	this.eth0Txdrops = eth0Txdrops;
	this.eth1Rxerrs = eth1Rxerrs;
	this.eth1Rxbyts = eth1Rxbyts;
	this.eth1Rxpcks = eth1Rxpcks;
	this.eth1Rxdrops = eth1Rxdrops;
	this.eth1Txerrs = eth1Txerrs;
	this.eth1Txbyts = eth1Txbyts;
	this.eth1Txpcks = eth1Txpcks;
	this.eth1Txdrops = eth1Txdrops;
	this.sdaRkbs = sdaRkbs;
	this.sdaWkbs = sdaWkbs;
	this.sdbRkbs = sdbRkbs;
	this.sdbWkbs = sdbWkbs;
	this.sdcRkbs = sdcRkbs;
	this.sdcWkbs = sdcWkbs;
	this.sddRkbs = sddRkbs;
	this.sddWkbs = sddWkbs;
	this.cpuIdlePcnt = cpuIdlePcnt;
	this.cpuNicePcnt = cpuNicePcnt;
	this.cpuSystemPcnt = cpuSystemPcnt;
	this.cpuUserPcnt = cpuUserPcnt;
	this.cpuHirqPcnt = cpuHirqPcnt;
	this.cpuSirqPcnt = cpuSirqPcnt;
	this.iowaitPcnt = iowaitPcnt;
	this.memBuffersPcnt = memBuffersPcnt;
	this.memUsedPcnt = memUsedPcnt;
	this.eth0BusyPcnt = eth0BusyPcnt;
	this.eth1BusyPcnt = eth1BusyPcnt;
	this.sdaBusyPcnt = sdaBusyPcnt;
	this.sdbBusyPcnt = sdbBusyPcnt;
	this.sdcBusyPcnt = sdcBusyPcnt;
	this.sddBusyPcnt = sddBusyPcnt;
	this.swapUsedPcnt = swapUsedPcnt;
    }

    public Timestamp getTimestamp() {
	return this.timestamp;
    }

    public void setTimestamp(Timestamp timestamp) {
	this.timestamp = timestamp;
    }

    public Integer getHost() {
	return this.host;
    }

    public void setHost(Integer host) {
	this.host = host;
    }

    public Double getLoad15() {
	return this.load15;
    }

    public void setLoad15(Double load15) {
	this.load15 = load15;
    }

    public Double getLoad5() {
	return this.load5;
    }

    public void setLoad5(Double load5) {
	this.load5 = load5;
    }

    public Double getLoad1() {
	return this.load1;
    }

    public void setLoad1(Double load1) {
	this.load1 = load1;
    }

    public Double getTaskTotal() {
	return this.taskTotal;
    }

    public void setTaskTotal(Double taskTotal) {
	this.taskTotal = taskTotal;
    }

    public Double getTaskRunning() {
	return this.taskRunning;
    }

    public void setTaskRunning(Double taskRunning) {
	this.taskRunning = taskRunning;
    }

    public Double getTaskSleep() {
	return this.taskSleep;
    }

    public void setTaskSleep(Double taskSleep) {
	this.taskSleep = taskSleep;
    }

    public Double getTaskStopped() {
	return this.taskStopped;
    }

    public void setTaskStopped(Double taskStopped) {
	this.taskStopped = taskStopped;
    }

    public Double getTaskZombie() {
	return this.taskZombie;
    }

    public void setTaskZombie(Double taskZombie) {
	this.taskZombie = taskZombie;
    }

    public Double getMemTotal() {
	return this.memTotal;
    }

    public void setMemTotal(Double memTotal) {
	this.memTotal = memTotal;
    }

    public Double getMemBuffers() {
	return this.memBuffers;
    }

    public void setMemBuffers(Double memBuffers) {
	this.memBuffers = memBuffers;
    }

    public Double getMemCached() {
	return this.memCached;
    }

    public void setMemCached(Double memCached) {
	this.memCached = memCached;
    }

    public Double getMemUsed() {
	return this.memUsed;
    }

    public void setMemUsed(Double memUsed) {
	this.memUsed = memUsed;
    }

    public Double getMemFree() {
	return this.memFree;
    }

    public void setMemFree(Double memFree) {
	this.memFree = memFree;
    }

    public Double getEth0Rxerrs() {
	return this.eth0Rxerrs;
    }

    public void setEth0Rxerrs(Double eth0Rxerrs) {
	this.eth0Rxerrs = eth0Rxerrs;
    }

    public Double getEth0Rxbyts() {
	return this.eth0Rxbyts;
    }

    public void setEth0Rxbyts(Double eth0Rxbyts) {
	this.eth0Rxbyts = eth0Rxbyts;
    }

    public Double getEth0Rxpcks() {
	return this.eth0Rxpcks;
    }

    public void setEth0Rxpcks(Double eth0Rxpcks) {
	this.eth0Rxpcks = eth0Rxpcks;
    }

    public Double getEth0Rxdrops() {
	return this.eth0Rxdrops;
    }

    public void setEth0Rxdrops(Double eth0Rxdrops) {
	this.eth0Rxdrops = eth0Rxdrops;
    }

    public Double getEth0Txerrs() {
	return this.eth0Txerrs;
    }

    public void setEth0Txerrs(Double eth0Txerrs) {
	this.eth0Txerrs = eth0Txerrs;
    }

    public Double getEth0Txbyts() {
	return this.eth0Txbyts;
    }

    public void setEth0Txbyts(Double eth0Txbyts) {
	this.eth0Txbyts = eth0Txbyts;
    }

    public Double getEth0Txpcks() {
	return this.eth0Txpcks;
    }

    public void setEth0Txpcks(Double eth0Txpcks) {
	this.eth0Txpcks = eth0Txpcks;
    }

    public Double getEth0Txdrops() {
	return this.eth0Txdrops;
    }

    public void setEth0Txdrops(Double eth0Txdrops) {
	this.eth0Txdrops = eth0Txdrops;
    }

    public Double getEth1Rxerrs() {
	return this.eth1Rxerrs;
    }

    public void setEth1Rxerrs(Double eth1Rxerrs) {
	this.eth1Rxerrs = eth1Rxerrs;
    }

    public Double getEth1Rxbyts() {
	return this.eth1Rxbyts;
    }

    public void setEth1Rxbyts(Double eth1Rxbyts) {
	this.eth1Rxbyts = eth1Rxbyts;
    }

    public Double getEth1Rxpcks() {
	return this.eth1Rxpcks;
    }

    public void setEth1Rxpcks(Double eth1Rxpcks) {
	this.eth1Rxpcks = eth1Rxpcks;
    }

    public Double getEth1Rxdrops() {
	return this.eth1Rxdrops;
    }

    public void setEth1Rxdrops(Double eth1Rxdrops) {
	this.eth1Rxdrops = eth1Rxdrops;
    }

    public Double getEth1Txerrs() {
	return this.eth1Txerrs;
    }

    public void setEth1Txerrs(Double eth1Txerrs) {
	this.eth1Txerrs = eth1Txerrs;
    }

    public Double getEth1Txbyts() {
	return this.eth1Txbyts;
    }

    public void setEth1Txbyts(Double eth1Txbyts) {
	this.eth1Txbyts = eth1Txbyts;
    }

    public Double getEth1Txpcks() {
	return this.eth1Txpcks;
    }

    public void setEth1Txpcks(Double eth1Txpcks) {
	this.eth1Txpcks = eth1Txpcks;
    }

    public Double getEth1Txdrops() {
	return this.eth1Txdrops;
    }

    public void setEth1Txdrops(Double eth1Txdrops) {
	this.eth1Txdrops = eth1Txdrops;
    }

    public Double getSdaRkbs() {
	return this.sdaRkbs;
    }

    public void setSdaRkbs(Double sdaRkbs) {
	this.sdaRkbs = sdaRkbs;
    }

    public Double getSdaWkbs() {
	return this.sdaWkbs;
    }

    public void setSdaWkbs(Double sdaWkbs) {
	this.sdaWkbs = sdaWkbs;
    }

    public Double getSdbRkbs() {
	return this.sdbRkbs;
    }

    public void setSdbRkbs(Double sdbRkbs) {
	this.sdbRkbs = sdbRkbs;
    }

    public Double getSdbWkbs() {
	return this.sdbWkbs;
    }

    public void setSdbWkbs(Double sdbWkbs) {
	this.sdbWkbs = sdbWkbs;
    }

    public Double getSdcRkbs() {
	return this.sdcRkbs;
    }

    public void setSdcRkbs(Double sdcRkbs) {
	this.sdcRkbs = sdcRkbs;
    }

    public Double getSdcWkbs() {
	return this.sdcWkbs;
    }

    public void setSdcWkbs(Double sdcWkbs) {
	this.sdcWkbs = sdcWkbs;
    }

    public Double getSddRkbs() {
	return this.sddRkbs;
    }

    public void setSddRkbs(Double sddRkbs) {
	this.sddRkbs = sddRkbs;
    }

    public Double getSddWkbs() {
	return this.sddWkbs;
    }

    public void setSddWkbs(Double sddWkbs) {
	this.sddWkbs = sddWkbs;
    }

    public Float getCpuIdlePcnt() {
	return this.cpuIdlePcnt;
    }

    public void setCpuIdlePcnt(Float cpuIdlePcnt) {
	this.cpuIdlePcnt = cpuIdlePcnt;
    }

    public Float getCpuNicePcnt() {
	return this.cpuNicePcnt;
    }

    public void setCpuNicePcnt(Float cpuNicePcnt) {
	this.cpuNicePcnt = cpuNicePcnt;
    }

    public Float getCpuSystemPcnt() {
	return this.cpuSystemPcnt;
    }

    public void setCpuSystemPcnt(Float cpuSystemPcnt) {
	this.cpuSystemPcnt = cpuSystemPcnt;
    }

    public Float getCpuUserPcnt() {
	return this.cpuUserPcnt;
    }

    public void setCpuUserPcnt(Float cpuUserPcnt) {
	this.cpuUserPcnt = cpuUserPcnt;
    }

    public Float getCpuHirqPcnt() {
	return this.cpuHirqPcnt;
    }

    public void setCpuHirqPcnt(Float cpuHirqPcnt) {
	this.cpuHirqPcnt = cpuHirqPcnt;
    }

    public Float getCpuSirqPcnt() {
	return this.cpuSirqPcnt;
    }

    public void setCpuSirqPcnt(Float cpuSirqPcnt) {
	this.cpuSirqPcnt = cpuSirqPcnt;
    }

    public Float getIowaitPcnt() {
	return this.iowaitPcnt;
    }

    public void setIowaitPcnt(Float iowaitPcnt) {
	this.iowaitPcnt = iowaitPcnt;
    }

    public Float getMemBuffersPcnt() {
	return this.memBuffersPcnt;
    }

    public void setMemBuffersPcnt(Float memBuffersPcnt) {
	this.memBuffersPcnt = memBuffersPcnt;
    }

    public Float getMemUsedPcnt() {
	return this.memUsedPcnt;
    }

    public void setMemUsedPcnt(Float memUsedPcnt) {
	this.memUsedPcnt = memUsedPcnt;
    }

    public Float getEth0BusyPcnt() {
	return this.eth0BusyPcnt;
    }

    public void setEth0BusyPcnt(Float eth0BusyPcnt) {
	this.eth0BusyPcnt = eth0BusyPcnt;
    }

    public Float getEth1BusyPcnt() {
	return this.eth1BusyPcnt;
    }

    public void setEth1BusyPcnt(Float eth1BusyPcnt) {
	this.eth1BusyPcnt = eth1BusyPcnt;
    }

    public Float getSdaBusyPcnt() {
	return this.sdaBusyPcnt;
    }

    public void setSdaBusyPcnt(Float sdaBusyPcnt) {
	this.sdaBusyPcnt = sdaBusyPcnt;
    }

    public Float getSdbBusyPcnt() {
	return this.sdbBusyPcnt;
    }

    public void setSdbBusyPcnt(Float sdbBusyPcnt) {
	this.sdbBusyPcnt = sdbBusyPcnt;
    }

    public Float getSdcBusyPcnt() {
	return this.sdcBusyPcnt;
    }

    public void setSdcBusyPcnt(Float sdcBusyPcnt) {
	this.sdcBusyPcnt = sdcBusyPcnt;
    }

    public Float getSddBusyPcnt() {
	return this.sddBusyPcnt;
    }

    public void setSddBusyPcnt(Float sddBusyPcnt) {
	this.sddBusyPcnt = sddBusyPcnt;
    }

    public Float getSwapUsedPcnt() {
	return this.swapUsedPcnt;
    }

    public void setSwapUsedPcnt(Float swapUsedPcnt) {
	this.swapUsedPcnt = swapUsedPcnt;
    }

}
