/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.chukwa.rest.objects;

// Generated May 28, 2009 3:39:53 PM by Hibernate Tools 3.2.4.GA
import java.sql.Timestamp;
/**
 * DfsNamenode generated by hbm2java
 */
public class DfsNameNode implements java.io.Serializable {
    static final long serialVersionUID = 9178762311502732711L;

    private Timestamp timestamp;
    private String host;
    private Double addBlockOps;
    private Double blocksCorrupted;
    private Double createFileOps;
    private Double deleteFileOps;
    private Double filesCreated;
    private Double filesRenamed;
    private Double filesDeleted;
    private Double getBlockLocations;
    private Double getListingOps;
    private Double safeModeTime;
    private Double syncsAvgTime;
    private Double syncsNumOps;
    private Double transactionsAvgTime;
    private Double transactionsNumOps;
    private Double blockReportAvgTime;
    private Double blockReportNumOps;
    private Double fsImageLoadTime;

    public DfsNameNode() {
    }

    public DfsNameNode(Timestamp timestamp, String host, Double addBlockOps,
		       Double blocksCorrupted, Double createFileOps, Double deleteFileOps,
		       Double filesCreated, Double filesRenamed, Double filesDeleted,
		       Double getBlockLocations, Double getListingOps,
		       Double safeModeTime, Double syncsAvgTime, Double syncsNumOps,
		       Double transactionsAvgTime, Double transactionsNumOps,
		       Double blockReportAvgTime, Double blockReportNumOps,
		       Double fsImageLoadTime) {
	this.timestamp = timestamp;
	this.host=host;
	this.addBlockOps = addBlockOps;
	this.blocksCorrupted = blocksCorrupted;
	this.createFileOps = createFileOps;
	this.deleteFileOps = deleteFileOps;
	this.filesCreated = filesCreated;
	this.filesRenamed = filesRenamed;
	this.filesDeleted = filesDeleted;
	this.getBlockLocations = getBlockLocations;
	this.getListingOps = getListingOps;
	this.safeModeTime = safeModeTime;
	this.syncsAvgTime = syncsAvgTime;
	this.syncsNumOps = syncsNumOps;
	this.transactionsAvgTime = transactionsAvgTime;
	this.transactionsNumOps = transactionsNumOps;
	this.blockReportAvgTime = blockReportAvgTime;
	this.blockReportNumOps = blockReportNumOps;
	this.fsImageLoadTime = fsImageLoadTime;
    }

    public Timestamp getTimestamp() {
	return this.timestamp;
    }

    public void setTimestamp(Timestamp timestamp) {
	this.timestamp=timestamp;
    }

    public String getHost() {
	return this.host;
    }

    public void setHost(String host) {
	this.host=host;
    }

    public Double getAddBlockOps() {
	return this.addBlockOps;
    }

    public void setAddBlockOps(Double addBlockOps) {
	this.addBlockOps = addBlockOps;
    }

    public Double getBlocksCorrupted() {
	return this.blocksCorrupted;
    }

    public void setBlocksCorrupted(Double blocksCorrupted) {
	this.blocksCorrupted = blocksCorrupted;
    }

    public Double getCreateFileOps() {
	return this.createFileOps;
    }

    public void setCreateFileOps(Double createFileOps) {
	this.createFileOps = createFileOps;
    }

    public Double getDeleteFileOps() {
	return this.deleteFileOps;
    }

    public void setDeleteFileOps(Double deleteFileOps) {
	this.deleteFileOps = deleteFileOps;
    }

    public Double getFilesCreated() {
	return this.filesCreated;
    }

    public void setFilesCreated(Double filesCreated) {
	this.filesCreated = filesCreated;
    }

    public Double getFilesRenamed() {
	return this.filesRenamed;
    }

    public void setFilesRenamed(Double filesRenamed) {
	this.filesRenamed = filesRenamed;
    }

    public Double getFilesDeleted() {
	return this.filesDeleted;
    }

    public void setFilesDeleted(Double filesDeleted) {
	this.filesDeleted = filesDeleted;
    }

    public Double getGetBlockLocations() {
	return this.getBlockLocations;
    }

    public void setGetBlockLocations(Double getBlockLocations) {
	this.getBlockLocations = getBlockLocations;
    }

    public Double getGetListingOps() {
	return this.getListingOps;
    }

    public void setGetListingOps(Double getListingOps) {
	this.getListingOps = getListingOps;
    }

    public Double getSafeModeTime() {
	return this.safeModeTime;
    }

    public void setSafeModeTime(Double safeModeTime) {
	this.safeModeTime = safeModeTime;
    }

    public Double getSyncsAvgTime() {
	return this.syncsAvgTime;
    }

    public void setSyncsAvgTime(Double syncsAvgTime) {
	this.syncsAvgTime = syncsAvgTime;
    }

    public Double getSyncsNumOps() {
	return this.syncsNumOps;
    }

    public void setSyncsNumOps(Double syncsNumOps) {
	this.syncsNumOps = syncsNumOps;
    }

    public Double getTransactionsAvgTime() {
	return this.transactionsAvgTime;
    }

    public void setTransactionsAvgTime(Double transactionsAvgTime) {
	this.transactionsAvgTime = transactionsAvgTime;
    }

    public Double getTransactionsNumOps() {
	return this.transactionsNumOps;
    }

    public void setTransactionsNumOps(Double transactionsNumOps) {
	this.transactionsNumOps = transactionsNumOps;
    }

    public Double getBlockReportAvgTime() {
	return this.blockReportAvgTime;
    }

    public void setBlockReportAvgTime(Double blockReportAvgTime) {
	this.blockReportAvgTime = blockReportAvgTime;
    }

    public Double getBlockReportNumOps() {
	return this.blockReportNumOps;
    }

    public void setBlockReportNumOps(Double blockReportNumOps) {
	this.blockReportNumOps = blockReportNumOps;
    }

    public Double getFsImageLoadTime() {
	return this.fsImageLoadTime;
    }

    public void setFsImageLoadTime(Double fsImageLoadTime) {
	this.fsImageLoadTime = fsImageLoadTime;
    }

}
